<template>
  <div class="p-2">
    <!--    <transition :enter-active-class="proxy?.animate.searchAnimate.enter" :leave-active-class="proxy?.animate.searchAnimate.leave">-->
    <!--      <div class="mb-[10px]" v-show="showSearch">-->
    <!--        <el-card shadow="hover">-->
    <!--          <el-form :model="queryParams" ref="queryFormRef" :inline="true" label-width="68px">-->

    <!--            <el-form-item label="原名" prop="originalName">-->
    <!--              <el-input v-model="queryParams.originalName" placeholder="请输入原名" clearable style="width: 200px" @keyup.enter="handleQuery" />-->
    <!--            </el-form-item>-->

    <!--            <el-form-item>-->
    <!--              <el-button type="primary" icon="search" @click="handleQuery">搜索</el-button>-->
    <!--              <el-button icon="Refresh" @click="resetQuery">重置</el-button>-->
    <!--            </el-form-item>-->
    <!--          </el-form>-->
    <!--        </el-card>-->
    <!--      </div>-->
    <!--    </transition>-->

    <el-card shadow="hover">
      <template #header>
        <el-row style="text-align: center">
          <el-col style="display:flex;justify-content: center;align-items: center;min-height: calc(100vh - 160px)">
            <el-button
              style="min-height: 5rem;min-width: 21rem;font-size: 2rem;border-radius: 40px"
              type="primary"
              plain
              icon="Upload"
              @click="handleFile"
              v-if="isContains(useUserStore().permissions, 'system:oss:upload')"
              >上传文件</el-button
            >
          </el-col>

          <!--          <el-col :span="1.5">-->
          <!--            <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete()" v-if="isContains(useUserStore().permissions, 'system:oss:remove')">-->
          <!--              删除-->
          <!--            </el-button>-->
          <!--          </el-col>-->
          <!--          <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>-->
        </el-row>
      </template>
      <!--      <el-table-->
      <!--        v-loading="loading"-->
      <!--        :data="ossList"-->
      <!--        @selection-change="handleSelectionChange"-->
      <!--        :header-cell-class-name="handleHeaderClass"-->
      <!--        @header-click="handleHeaderCLick"-->
      <!--        v-if="showTable"-->
      <!--      >-->
      <!--        <el-table-column type="index"  />-->
      <!--&lt;!&ndash;        <el-table-column type="selection" width="55" align="center" />&ndash;&gt;-->
      <!--        <el-table-column label="原名" align="center" prop="originalName" />-->
      <!--        <el-table-column label="上传时间" align="center" prop="createTime" />-->
      <!--        <el-table-column label="操作" align="center" class-name="small-padding fixed-width">-->
      <!--          <template #default="scope">-->
      <!--            <el-tooltip content="查看提取码" placement="top">-->
      <!--              <el-button link type="primary" icon="Search" @click="handleCode(scope.row)" v-if="isContains(useUserStore().permissions, 'system:oss:view')"></el-button>-->
      <!--            </el-tooltip>-->
      <!--            <el-tooltip content="下载" placement="top">-->
      <!--              <el-button link type="primary" icon="Download" @click="handleDownload(scope.row)" v-if="isContains(useUserStore().permissions, 'system:oss:download')"></el-button>-->
      <!--            </el-tooltip>-->
      <!--            <el-tooltip content="删除" placement="top">-->
      <!--              <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-if="isContains(useUserStore().permissions, 'system:oss:remove')"></el-button>-->
      <!--            </el-tooltip>-->
      <!--          </template>-->
      <!--        </el-table-column>-->
      <!--      </el-table>-->

      <!--      <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />-->
    </el-card>
    <!-- 添加或修改OSS对象存储对话框 -->
    <el-dialog :title="dialog.title" v-model="dialog.visible" width="500px" append-to-body>
      <el-form ref="ossFormRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="文件名">
          <fileUpload
            ref="childFile"
            @closePopup="getList();lookPawsd($event)"
            @openPopup="lookPawsd($event)"
            v-model="form.file"
            v-if="type === 0"
          />
          <imageUpload v-model="form.file" v-if="type === 1" />
          <video-upload v-model="form.file" v-if="type === 2" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
    <el-dialog :title="titleDownload" v-model="visibleCode" width="500px" append-to-body>
      <div style="width: 100%;text-align: center">
        <p style="color: red; font-size: 20px">提取码将会在24小时后失效请尽快下载!</p>
        <span v-show="titleDownload=='查看提取码'" style="font-size: 80px;">{{testtxt}}</span>
      </div>
      <el-input
        style="margin: 10px 0"
        ref="inputRef"
        :style="inputSty"
        v-show="titleDownload=='输入提取码'"
        v-model="pasTxt"
        v-if="isContains(useUserStore().permissions, 'system:oss:download')"
        placeholder="请输入文件提取码"
      ></el-input>
      <el-input
        style="margin: 10px 0"
        ref="inputRef"
        :style="inputSty"
        v-show="titleDownload=='请输入提取码'"
        v-model="pasTxt"
        placeholder="请输入文件提取码"
      ></el-input>
      <!--      <el-button link type="primary"   v-show="titleDownload=='输入提取码'" icon="Download" @click="handleDownloadFile()" v-if="isContains(useUserStore().permissions, 'system:oss:download')">下载</el-button>-->
      <!--      <el-button link type="primary"   v-show="titleDownload=='请输入提取码'"  icon="Delete" @click="delFile()" >删除</el-button>-->
      <template #footer>
        <div class="dialog-footer">
          <el-button
            link
            type="primary"
            v-show="titleDownload=='输入提取码'"
            icon="Download"
            @click="handleDownloadFile()"
            v-if="isContains(useUserStore().permissions, 'system:oss:download')"
            >下载</el-button
          >
          <el-button link type="primary" v-show="titleDownload=='请输入提取码'" icon="Delete" @click="delFile()">删除</el-button>
          <el-button type="primary" @click="visibleCode = false">确 定</el-button>
        </div>
      </template>
    </el-dialog>

    <!-- 进度条 -->
    <el-dialog v-model="dialogVisible" title="" width="37%" :close-on-click-modal="false" :close-on-press-escape="false" :show-close="false">
      <el-progress type="dashboard" :percentage="percentage2" style="display: flex;justify-content: center" :color="colors" />
    </el-dialog>
  </div>
</template>

<script setup name="Oss" lang="ts">
import { listOss, delOss, createUser, examineIds } from '@/api/system/oss';
import { OssForm, OssQuery, OssVO } from '@/api/system/oss/types';
import { to as tos } from 'await-to-js';
import useUserStore from '@/store/modules/user';
import { getToken, setToken } from '@/utils/auth';
import usePermissionStore from '@/store/modules/permission';
import { isHttp } from '@/utils/validate';
import router from '@/router';
import { onMounted, ref } from 'vue';
import { Minus, Plus } from '@element-plus/icons-vue';
import { ElMessageBox } from 'element-plus';

const dialogVisible = ref(false);

const state = reactive({
  mytime: 0 //定义定时器
});
const percentage = ref(10);
const percentage2 = ref(0);

const colors = [
  { color: '#f56c6c', percentage: 20 },
  { color: '#e6a23c', percentage: 40 },
  { color: '#5cb87a', percentage: 60 },
  { color: '#1989fa', percentage: 80 },
  { color: '#6f7ad3', percentage: 100 }
];

const increase = () => {
  percentage.value += 10;
  if (percentage.value > 100) {
    percentage.value = 100;
  }
};
const decrease = () => {
  percentage.value -= 10;
  if (percentage.value < 0) {
    percentage.value = 0;
  }
};
onMounted(() => {});
watch(percentage2, (new1, new2) => {
  console.log(new1, new2);
  if (new1 == 95) {
    clearInterval(state.mytime);
    state.mytime = 0;
  }
});
const { proxy } = getCurrentInstance() as ComponentInternalInstance;

const ossList = ref<OssVO[]>([]);
const showTable = ref(true);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const type = ref(0);
const previewListResource = ref(true);
const dateRangeCreateTime = ref<[DateModelType, DateModelType]>(['', '']);
const visibleCode = ref(false);
const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});
const testtxt = ref<any>();
const pasTxt = ref<any>();
const titleDownload = ref<any>();
const downIds = ref<any>();
const inputRef = ref<any>();
const inputSty = ref<any>();
const currentIp = ref('');
const childFile = ref<any>();
const figType = ref<any>();
// 默认排序
const defaultSort = ref({ prop: 'createTime', order: 'ascending' });

const ossFormRef = ref<ElFormInstance>();
const queryFormRef = ref<ElFormInstance>();

const initFormData = {
  file: undefined
};
const data = reactive<PageData<OssForm, OssQuery>>({
  form: { ...initFormData },
  // 查询参数
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    fileName: '',
    originalName: '',
    fileSuffix: '',
    createTime: '',
    service: '',
    orderByColumn: defaultSort.value.prop,
    isAsc: defaultSort.value.order
  },
  rules: {
    file: [{ required: true, message: '文件不能为空', trigger: 'blur' }]
  }
});

const { queryParams, form, rules } = toRefs(data);
const sure = () => {
  testtxt.value += 1;
};
/** 查询OSS对象存储列表 */
const getList = async () => {
  loading.value = true;
  const res = await proxy?.getConfigKey('sys.oss.previewListResource');
  previewListResource.value = res?.data === undefined ? true : res.data === 'true';
  const response = await listOss(proxy?.addDateRange(queryParams.value, dateRangeCreateTime.value, 'CreateTime'));
  ossList.value = response.rows;
  total.value = response.total;
  loading.value = false;
  showTable.value = true;
};
function checkFileSuffix(fileSuffix: string[]) {
  let arr = ['png', 'jpg', 'jpeg'];
  return arr.some((type) => {
    return fileSuffix.indexOf(type) > -1;
  });
}
/** 取消按钮 */
function cancel() {
  dialog.visible = false;
  reset();
}
/** 表单重置 */
function reset() {
  form.value = { ...initFormData };
  ossFormRef.value?.resetFields();
}
/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}
/** 重置按钮操作 */
function resetQuery() {
  showTable.value = false;
  dateRangeCreateTime.value = ['', ''];
  queryFormRef.value?.resetFields();
  queryParams.value.orderByColumn = defaultSort.value.prop;
  queryParams.value.isAsc = defaultSort.value.order;
  handleQuery();
}
/** 选择条数  */
function handleSelectionChange(selection: OssVO[]) {
  ids.value = selection.map((item) => item.ossId);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}
/** 设置列的排序为我们自定义的排序 */
const handleHeaderClass = ({ column }: any): any => {
  column.order = column.multiOrder;
};
/** 点击表头进行排序 */
const handleHeaderCLick = (column: any) => {
  if (column.sortable !== 'custom') {
    return;
  }
  switch (column.multiOrder) {
    case 'descending':
      column.multiOrder = 'ascending';
      break;
    case 'ascending':
      column.multiOrder = '';
      break;
    default:
      column.multiOrder = 'descending';
      break;
  }
  handleOrderChange(column.property, column.multiOrder);
};
const handleOrderChange = (prop: string, order: string) => {
  let orderByArr = queryParams.value.orderByColumn ? queryParams.value.orderByColumn.split(',') : [];
  let isAscArr = queryParams.value.isAsc ? queryParams.value.isAsc.split(',') : [];
  let propIndex = orderByArr.indexOf(prop);
  if (propIndex !== -1) {
    if (order) {
      //排序里已存在 只修改排序
      isAscArr[propIndex] = order;
    } else {
      //如果order为null 则删除排序字段和属性
      isAscArr.splice(propIndex, 1); //删除排序
      orderByArr.splice(propIndex, 1); //删除属性
    }
  } else {
    //排序里不存在则新增排序
    orderByArr.push(prop);
    isAscArr.push(order);
  }
  //合并排序
  queryParams.value.orderByColumn = orderByArr.join(',');
  queryParams.value.isAsc = isAscArr.join(',');
  getList();
};
/** 任务日志列表查询 */
/** 文件按钮操作 */
const handleFile = () => {
  percentage2.value = 0;
  reset();
  type.value = 0;
  dialog.visible = true;
  dialog.title = '上传文件';
};
/** 图片按钮操作 */
const handleImage = () => {
  reset();
  type.value = 1;
  dialog.visible = true;
  dialog.title = '上传图片';
};
const handleVideo = () => {
  reset();
  type.value = 2;
  dialog.visible = true;
  dialog.title = '上传视频';
};
/** 提交按钮 */

const submitForm = async () => {
  const number = await childFile.value.handleCilck();
  if (number > 0) {
    dialog.visible = false;
    dialogVisible.value = true;
    state.mytime = setInterval(() => {
      percentage2.value = (percentage2.value % 100) + 5;
    }, 500);
  }
};
const lookPawsd = async (row: any) => {
  console.log(row);
  // row.msg = ':/"123456'

  clearInterval(state.mytime);
  state.mytime = 0;
  // if(row == '123123'){
  //   dialogVisible.value = true;
  //   state.mytime = setInterval(() => {
  //       percentage2.value = (percentage2.value % 100) + 5
  //     }, 500)
  // }
  // else{
  dialogVisible.value = false;
  clearInterval(state.mytime);
  state.mytime = 0;
  testtxt.value = row.msg;
  // testtxt.value = row.msg.slice(2);
  titleDownload.value = '查看提取码';
  pasTxt.value = '';
  visibleCode.value = true;
  // }
};
const handleCode = async (row: OssVO) => {
  console.log(row, row.ossId);

  await examineIds(row.ossId).then((res) => {
    console.log(res);
    if (res.code == 200) {
      testtxt.value = res.msg;
      titleDownload.value = '查看提取码';
      pasTxt.value = '';
      // inputSty.value ={
      //   border: '1px solid blue'
      // }
      visibleCode.value = true;
    } else {
      const message = res.msg;
      proxy?.$modal.msgSuccess(message);
    }
  });
};
/** 下载按钮操作 */
const handleDownload = (row: OssVO) => {
  titleDownload.value = '输入提取码';
  pasTxt.value = '';
  inputSty.value = {
    border: '1px solid blue',
    borderRadius: '5px'
  };
  visibleCode.value = true;
  downIds.value = ref(row.ossId);
  console.log(toRaw(downIds.value.value));
};
const delFile = async () => {
  let oss = figType.value + '/' + pasTxt.value;
  await delOss(oss).finally(() => (loading.value = false));
  await getList();
  proxy?.$modal.msgSuccess('删除成功');
  visibleCode.value = false;
};
const handleDownloadFile = () => {
  console.log(downIds.value);
  if (pasTxt.value) {
    proxy?.$download.ossDown(downIds.value.value, pasTxt.value);
  } else {
    console.log(inputRef.value);
    inputSty.value = {
      border: '1px solid red'
    };
    // inputRef.value.style.border = '1px solid red'
  }
  visibleCode.value = false;
};
/** 用户状态修改  */
/** 删除按钮操作 */
const handleDelete = async (row?: OssVO) => {
  let ossIds = row?.ossId || ids.value;
  titleDownload.value = '请输入提取码';
  pasTxt.value = '';
  inputSty.value = {
    border: '1px solid blue',
    borderRadius: '5px'
  };
  visibleCode.value = true;
  figType.value = ossIds;
  console.log(figType);
  // await proxy?.$modal.confirm('是否确认删除OSS对象存储编号为"' + ossIds + '"的数据项?');
  // loading.value = true;
  // ossIds = ossIds+'/'+pasTxt.value;
  // await delOss(ossIds).finally(() => loading.value = false);
  // await getList();
  // proxy?.$modal.msgSuccess("删除成功");
};
const refreshPage = async () => {
  const accessRoutes = await usePermissionStore().generateRoutes();
  console.log(accessRoutes, 'accessRoutes', router);
  // 根据roles权限生成可访问的路由表
  accessRoutes.forEach((route) => {
    if (!isHttp(route.path)) {
      router.addRoute(route); // 动态添加可访问路由表
    }
  });
  // location.reload();
};
const isContains = (arr: string | any[], value: any) => {
  // return arr.includes(value);
  return true;
};

const setAddUser = async (val: any | number | (string | number)[]) => {
  console.log(val);
  const res = await createUser(val);
  console.log(res);
  if (res.code == 200) {
    const data = res.data;
    setToken(data.access_token);
    const [err] = await tos(useUserStore().getInfo());
    console.log('useUserStore', useUserStore, err);
    await getList();

    // await refreshPage()

    console.log('permissions', useUserStore().permissions, 'system:oss:upload');
    // token.value = data.access_token;
  }
};
// watch(() => value.value, (newValue) => {
//   if (newValue) {
//     showValue.value = true;
//   } else {
//     showValue.value = false;
//   }
// });
onBeforeMount(async () => {
  console.log('第一', useUserStore().permissions);
  // try {
  //   // 使用fetch API获取当前IP地址
  //   await fetch('https://api.ipify.org/?format=json')
  //     .then(response => response.json())
  //     .then(async data => {
  //       currentIp.value = data.ip;
  //       let obj = {
  //         username: data.ip
  //       }
  //       await setAddUser(obj)
  //     })
  //     .catch(error => {
  //       console.error('获取IP地址失败：', error);
  //     });
  // } catch (error) {
  //   console.log(error);
  // }
});
onMounted(async () => {
  console.log('第二aaaaaaa', useUserStore().permissions);
  // 等待 useUserStore() 方法的 getInfo() 方法返回结果并赋值给 err 变量
  // const [err] = await tos(useUserStore().getInfo());
  if (getToken()) {
    console.log('有token');
    await getList();
  } else {
    console.log('无token');

    router.push('/login');
  }
  // 调用 getList() 方法
});
</script>
